=== modified file 'bzrlib/add.py'
--- bzrlib/add.py	2012-02-06 23:38:33 +0000
+++ bzrlib/add.py	2012-02-21 12:53:02 +0000
@@ -127,15 +127,13 @@
         we look for a file with the same name in that directory.
         Else, we look for an entry in the base tree with the same path.
         """
-
         if self.base_tree.has_id(parent_ie.file_id):
-            # FIXME: Handle nested trees
-            base_parent_ie = self.base_tree.root_inventory[parent_ie.file_id]
-            base_child_ie = base_parent_ie.children.get(
+            base_path = osutils.pathjoin(
+                self.base_tree.id2path(parent_ie.file_id),
                 osutils.basename(path))
-            if base_child_ie is not None:
-                return (base_child_ie.file_id,
-                        self.base_tree.id2path(base_child_ie.file_id))
+            base_id = self.base_tree.path2id(base_path)
+            if base_id is not None:
+                return (base_id, base_path)
         full_base_path = osutils.pathjoin(self.base_path, path)
         # This may return None, but it is our last attempt
         return self.base_tree.path2id(full_base_path), full_base_path

=== modified file 'bzrlib/tree.py'
--- bzrlib/tree.py	2012-02-17 15:57:53 +0000
+++ bzrlib/tree.py	2012-02-21 12:53:02 +0000
@@ -195,6 +195,15 @@
         """
         raise NotImplementedError(self.iter_entries_by_dir)
 
+    def iter_child_entries(self, file_id, path=None):
+        """Iterate over the children of a directory or tree reference.
+
+        :param file_id: File id of the directory/tree-reference
+        :param path: Optional path of the directory
+        :return: Iterator over (name, entry) tuples
+        """
+        raise NotImplementedError(self.iter_child_entries)
+
     def list_files(self, include_root=False, from_dir=None, recursive=True):
         """List all files in this tree.
 
@@ -871,6 +880,11 @@
         return self.root_inventory.iter_entries_by_dir(
             specific_file_ids=inventory_file_ids, yield_parents=yield_parents)
 
+    @needs_read_lock
+    def iter_child_entries(self, file_id, path=None):
+        inv, inv_file_id = self._unpack_file_id(file_id)
+        return inv[inv_file_id].children.iteritems()
+
     @deprecated_method(deprecated_in((2, 5, 0)))
     def get_file_by_path(self, path):
         return self.get_file(self.path2id(path), path)

